#pragma once

#include "Routines/RandomNumber.h"

class DrawTransition
{
public:
	enum eEffect {
		eWipeUp, eWipeRight, eWipeLeft, eWipeDown,
		eRectOut, eHorizontalBlindOut, eVerticalBlindOut,
		eMoveRight, eMoveLeft,
		eNumEffects // Always last
	};

	DrawTransition();
	bool GetIsDrawingTransition()
	{
		return m_bIsDrawingTransition;
	}

	void FillEffect(ATL_DRAWINFO& di);
	void TranslateEffect(ATL_DRAWINFO& di);

	void StartRandom();
	void Start(eEffect effect);
	void Draw(ATL_DRAWINFO& di);

	ATL_DRAWINFO* BeginDraw(ATL_DRAWINFO& di);

protected:
	int m_nMaxSteps;
	int m_nCurrentStep;
	bool m_bIsDrawingTransition;
	eEffect m_Effect;
	CRandomNumber m_Random;

	ATL_DRAWINFO m_DrawInfo;
};
