#pragma once

class MyTimeZone
{
public:
	MyTimeZone();
	void SetBrazilZone();

	const TIME_ZONE_INFORMATION& GetInfo() const
		{ return m_TzInfo; }
protected:
	TIME_ZONE_INFORMATION m_TzInfo;
};


class MyTime
{
public:
	MyTime();

	int GetMilliSecondTimeDifferenceFromNow();
	int GetMilliSecondTimeDifference(const MyTime& otherTime);

	void AppendTwoDigit(TCHAR* str, int num, bool bInsertZero = true);

	void SetCurrentUTC();
	void Set(int nYear, int nMonth, int nDay = 1, int nHour = 0, int nMinute = 0, int nSecond = 0);

	void SplitMilliSecondTimeDifference(int val);

	int GetYear() const   { return m_Time.wYear; }
	int GetMonth() const  { return m_Time.wMonth; }
	int GetDay() const    { return m_Time.wDay; }
	int GetHour() const   { return m_Time.wHour; }
	int GetMinute() const { return m_Time.wMinute; }
	int GetSecond() const { return m_Time.wSecond; }

	void AppendPeriodOfTime(TCHAR* pStr);

	void AppendTime(TCHAR* pStr);

	void ChangeToTimeZone(MyTimeZone& tz);

	const SYSTEMTIME& GetTime() const
	{
		return m_Time;
	}
protected:
	SYSTEMTIME m_Time;
};
