
// ScottsClockCtrl.h : Declaration of the CScottsClockCtrl

#ifndef __SCOTTSCLOCKCTRL_H_
#define __SCOTTSCLOCKCTRL_H_

#include "resource.h"       // main symbols
#include "DrawTransition.h"
#include "MyTime.h"

/////////////////////////////////////////////////////////////////////////////
// CScottsClockCtrl
class ATL_NO_VTABLE CScottsClockCtrl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CScottsClockCtrl, &CLSID_ScottsClockCtrl>,
	public CComControl<CScottsClockCtrl>,
	public IDispatchImpl<IScottsClockCtrl, &IID_IScottsClockCtrl, &LIBID_INTERNETCLOCKLib>,
	public IProvideClassInfo2Impl<&CLSID_ScottsClockCtrl, NULL, &LIBID_INTERNETCLOCKLib>,
	public IPersistStreamInitImpl<CScottsClockCtrl>,
	public IPersistStorageImpl<CScottsClockCtrl>,
	public IQuickActivateImpl<CScottsClockCtrl>,
	public IOleControlImpl<CScottsClockCtrl>,
	public IOleObjectImpl<CScottsClockCtrl>,
	public IOleInPlaceActiveObjectImpl<CScottsClockCtrl>,
	public IViewObjectExImpl<CScottsClockCtrl>,
	public IOleInPlaceObjectWindowlessImpl<CScottsClockCtrl>,
	public IDataObjectImpl<CScottsClockCtrl>,
	public ISpecifyPropertyPagesImpl<CScottsClockCtrl>,
	public IObjectSafetyImpl<CScottsClockCtrl> // SAK Added
{
public:
	CScottsClockCtrl();
	~CScottsClockCtrl();

	enum { 
		eShowFirst = 0, 
		eShowTimeInBrazil = 0, 
		eShowTimeTillStuffArrives,
		eShowTimeDifference, 
		eShowBrazilPopulation,
		eShowLast, 
	};

	enum {
		k_RotateEvery = 6, // Every n seconds
		k_nNumMilliseconds = 66, // fifteen frames per second
		k_nMaxMessages = 10,
	};

	DECLARE_REGISTRY_RESOURCEID(IDR_SCOTTSCLOCKCTRL)

BEGIN_COM_MAP(CScottsClockCtrl)
	COM_INTERFACE_ENTRY(IScottsClockCtrl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IMPL(IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject2, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleInPlaceObject, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY_IMPL(IOleControl)
	COM_INTERFACE_ENTRY_IMPL(IOleObject)
	COM_INTERFACE_ENTRY_IMPL(IQuickActivate)
	COM_INTERFACE_ENTRY_IMPL(IPersistStorage)
	COM_INTERFACE_ENTRY_IMPL(IPersistStreamInit)
	COM_INTERFACE_ENTRY_IMPL(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY_IMPL(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_IMPL(IObjectSafety) // SAK Added
END_COM_MAP()

BEGIN_PROPERTY_MAP(CScottsClockCtrl)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
   PROP_ENTRY("Message1", 1, CLSID_NULL )
#ifndef UNDER_CE
	PROP_PAGE(CLSID_StockColorPage)
#endif
END_PROPERTY_MAP()


BEGIN_MSG_MAP(CScottsClockCtrl)
	MESSAGE_HANDLER(WM_PAINT, OnPaint)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_KILLFOCUS, OnKillFocus)
	MESSAGE_HANDLER(WM_TIMER, OnTimerEvent)
END_MSG_MAP()


// IViewObjectEx
	STDMETHOD(GetViewStatus)(DWORD* pdwStatus)
	{
		ATLTRACE(_T("IViewObjectExImpl::GetViewStatus\n"));
		*pdwStatus = VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE;
		return S_OK;
	}

protected:
	void CalcBrazilTimeString(TCHAR* str);
	void CalcBrazilTime(MyTime& localTime);
	
	void CalcTimeInBrazil(MyTime& timeDiff);
	void CalcTimeInBrazilString(TCHAR* str);

	void CalcTimeTillStuffArrives(MyTime& timeDiff, bool& bHasArrived);
	void CalcTimeTillStuffArrivesString(TCHAR* str);

	void CScottsClockCtrl::CalcBrazilPopulation(TCHAR* work);

// IScottsClockCtrl
public:
	BOOL SetMessage(int nIndex, const CComBSTR& str);
	STDMETHOD(get_Message1)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_Message1)(/*[in]*/ BSTR newVal);
	HRESULT OnDraw(ATL_DRAWINFO& di);

	void DrawInfo(ATL_DRAWINFO& di);

	LRESULT OnTimerEvent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	void TurnTimerOn();
protected:
	int m_bTimerOn;
	int m_nMilliSecCount;
	int m_nSecCount;
	int m_eShowString;
	DrawTransition m_Transition;

	CComBSTR m_Messages[k_nMaxMessages];
};


#endif //__SCOTTSCLOCKCTRL_H_
